package cn.iocoder.yudao.module.rescue.service;



import cn.iocoder.yudao.module.rescue.domain.DriverInfo;
import cn.iocoder.yudao.module.rescue.domain.RescueInfo;
import cn.iocoder.yudao.module.rescue.dto.DriverInfo2Dto;
import cn.iocoder.yudao.module.rescue.dto.DriverInfoDto;
import cn.iocoder.yudao.module.rescue.vo.BuckleVO;
import cn.iocoder.yudao.module.rescue.vo.MoneyManagement;
import cn.iocoder.yudao.module.rescue.vo.ReturnCarVO;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;


import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Service接口
 *
 * @author ruoyi
 * @date 2023-07-14
 */
public interface IRescueInfoService extends IService<RescueInfo>
{
    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    public RescueInfo selectRescueInfoById(Long id);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param rescueInfo 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    IPage<RescueInfo> selectRescueInfoList(RescueInfo rescueInfo, Page<RescueInfo> page);
    IPage<RescueInfo> getKcList(RescueInfo rescueInfo, Page<RescueInfo> page);
    IPage<RescueInfo> getHcList(RescueInfo rescueInfo, Page<RescueInfo> page);

    void openKc(Long rescueId) throws Exception;

    IPage<RescueInfo> selectRescueInfoListByAdmin(RescueInfo rescueInfo, Page<RescueInfo> page);
    JSONObject rescueInfoDetail(Long rescueId);
    IPage<RescueInfo> selectRescueListSystem(Page<RescueInfo> page,RescueInfo rescueInfo);
    IPage<RescueInfo> selectRescueListSystem2(RescueInfo rescueInfo, Page<RescueInfo> page);
    JSONObject listData(RescueInfo rescueInfo);

    void designateDriver(Long rescueId,Long driverId) throws Exception;

    /**
     * 新增【请填写功能名称】
     *
     * @param rescueInfo 【请填写功能名称】
     * @return 结果
     */
    public void insertRescueInfo(RescueInfo rescueInfo);

    /**
     * 修改【请填写功能名称】
     *
     * @param rescueInfo 【请填写功能名称】
     * @return 结果
     */
    public int updateRescueInfo(RescueInfo rescueInfo);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键集合
     * @return 结果
     */
    public int deleteRescueInfoByIds(Long[] ids);

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    public void deleteRescueInfoById(Long id);
    IPage<DriverInfo> driverList(DriverInfoDto user, Page<DriverInfo> page);
    DriverInfo getDriverById(Long driverId);
    void addDriver(DriverInfo driverInfo) throws Exception;
    void updateDriver(DriverInfo user);
    void delDriver(Long[] ids);
    List<DriverInfo2Dto> driverListApp(DriverInfoDto driverInfoDto);
    List<DriverInfo2Dto>  driverInMap(DriverInfoDto driverInfoDto);
    Map<String, Integer> driverInMap2();
    void dealOverTimeRescue();
     void appointDriver(Long deptId,Long rescueId,String longitude,String latitude);
    Map<String,Object> getRescueStatistics(RescueInfo rescueInfo);
    Map<String,Object> getRescueStatisticsByAdmin(RescueInfo rescueInfo);
    void trajectoryJs(Long rescueId) throws Exception;
    List<MoneyManagement> moneyManagement(RescueInfo rescueInfo);
    List<MoneyManagement> moneyManagement2(List<RescueInfo> rescueInfos,String rescueStart);
    IPage<RescueInfo> getRescueInfoByDriver(RescueInfo rescueInfo, Page<RescueInfo> page);

    List<JSONObject> statisticsInfo(String type);

    /**
     * 获取扣车单位和具体数量
     * @author 小李
     * @date 10:46 2024/9/5
     **/
    List<BuckleVO> listBuckle();

    /**
     * 查看单个扣车单位信息
     * @author 小李
     * @date 11:44 2024/9/6
     * @param id 部门ID
     **/
    BuckleVO getBuckle(Long id);

    /**
     * 还车方法
     * @author 小李
     * @date 14:48 2024/9/6
     * @param returnCarVO 订单信息
     **/
    void returnCar(ReturnCarVO returnCarVO);

    /**
     * 入库方法
     * @author 小李
     * @date 10:37 2024/9/7
     * @param returnCarVO 订单信息
     **/
    void inBase(ReturnCarVO returnCarVO);

    /**
     * 获取经营分析
     * @param timeType
     * @return
     */
    List<Map<String, Object>> getManageAnalyze(String timeType);

    /**
     * 救援大屏获取出车次数统计
     * @param timeType
     * @return
     */
    Map<String, Object> getDrawOutAVehicleCount(String timeType);

    /**
     * 救援大屏获取司机排名
     * @param timeType
     * @return
     */
    List<Map<String, Object>> getDriverSort(String timeType);

    /**
     * 救援大屏获取救援订单占比接口
     * @return
     */
    List<Map<String, Object>> getRescueOrderByRoad();

    /**
     * 救援大屏获取救援详细数据
     * @param startTime
     * @param endTime
     * @return
     */
    Map<String, Object> getRescueMessage(String startTime, String endTime);
}
